
module Calc where


-------------------- simple calculator

scalc parse print
  = do inp <- prompt
       if null inp then return ()
          else do case parse inp of
                    [(v,"")]  -> print v
                    otherwise -> inperr
                  scalc parse print


-------------------- prompts and errors

prompt = putStr "\n >> " >> getLine >>= return

inperr = putStrLn " << error on input! >>"


-------------------- output formatting

fmt eq e = putStrLn (concat ["\n    ",   eq, " ", show e])
fmtNln e = putStr   (concat ["\n    ", "->", " ", show e])








-------------------- fancier calculator
--
-- should support description, help, commands, "browsing", etc.

{-

fcalc parse print desc 

  = ...
    where calc 
      = do inp <- prompt
           if null inp then return ()
              else do case parse inp of
                        [(v,"")]  -> print v
                        otherwise -> inperr
                      calc

-}