
module XCalc where

import XParse
import Parsing
import XDeno
import Calc


-------------------- command parsers

cmd (c,p,f) = symbol (':':c) >> p >>= return . f

cmds cpfs = foldr1 (+++) (map cmd cpfs)


-------------------- a denotational calculator with "Peano observations"

xcs = cmds [("v",term,val), ("n",term,num)]

xcalc = scalc (parse xcs) (fmt "=>")